--  Copyright (2008-2013) Cdric Coussinet (cedric.coussinet@nomoseed.net)
--
--  This program is free software: you can redistribute it and/or modify
--  it under the terms of the GNU Affero General Public License as published
--  by the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
--  GNU Affero General Public License for more details.

--  You should have received a copy of the GNU Affero General Public License
--  along with this program. If not, see <http://www.gnu.org/licenses/>

with Nomo.Numerics.Accurately;

with Nomo.Numerics.Fitting;

package Nomo.Interpreter.Premises_Index.Arrays.Maximization is

   use Numerics.Accurately;
   use Numerics.Fitting;
   use Premises_Index_Instance;

   function Get_Specificity_Log(This : in Internal_Premises;
                                I    : in Premise_Index) return Real_Accurately;
   pragma Precondition (I > 0);
   pragma Inline (Get_Specificity_Log);

   procedure Maximize (This        : in out Internal_Premises;
                       I           : in Premise_Index;
                       Fitting_Nbr : Count);
   pragma Precondition (I > 0);
   pragma Inline (Maximize);

end Nomo.Interpreter.Premises_Index.Arrays.Maximization;
